// ===================================================
//		GoGo board 1.2 Header file
// ===================================================
//     Version 1.00.2001100601
//
//  By Arnan (Roger) Sipitakiat
//  arnans@media.mit.edu
//
//	(c) 2001 Future of Learning Group,
//  MIT Media Laboratory
//
//

#include <defs_877.h>


/////////////////////////////////////////////////////////


#define CMD_PING			0x00
#define CMD_READ_SENSOR		0x01
#define CMD_MOTOR_CONTROL	0x02
#define CMD_MOTOR_POWER		0x03
#define CMD_TALK_TO_MOTOR	0x04
#define CMD_BURST_MODE		0x05





#define ACK_BYTE 		0b10101010   // 0xAA
#define InHeader1 		0x54
#define InHeader2 		0xfe
#define ReplyHeader1 	0x55
#define ReplyHeader2 	0xff

#define ON				1
#define OFF				0

// this is used in main(). Determinds how long to wait for the
// second command byte.
#define RETRY			100


//  Sensor read modes
#define NORMAL_READ  0
#define MAX_READ     1
#define MIN_READ     2
#define MEAN_READ    3


// this const defines the last command that is
// one byte long. Please refer to the CMD bits
// in the GoGo kit serial protocol

#define ONE_BYTE_CMD	3


// if there are any changes on the motor pins,
// you must update the timer ISR too, as the
// pins are hard coded there.

#define MTR1_CW			PIN_D6
#define MTR1_CC			PIN_D7
#define MTR1_EN			PIN_B0

#define MTR2_CW			PIN_B1
#define MTR2_CC			PIN_D4
#define MTR2_EN			PIN_D5

#define MTR3_CW			PIN_C5
#define MTR3_CC			PIN_B2
#define MTR3_EN			PIN_B3

#define MTR4_CW			PIN_B4
#define MTR4_CC			PIN_D3
#define MTR4_EN			PIN_C4

#define MTR5_CW			PIN_D2
#define MTR5_CC			PIN_B5
#define MTR5_EN			PIN_B6

#define MTR6_CW			PIN_B7
#define MTR6_CC			PIN_D1
#define MTR6_EN			PIN_D0


#define PIC_TRIS_B   0b00000000
#define PIC_TRIS_A	0b00101111
#define PIC_TRIS_C	0b10000000
#define PIC_TRIS_D	0b00000000
#define PIC_TRIS_E	0b00000111




#define RED_LED         PIN_C3  // (output) Red LED (low true)
#define GREEN_LED		   PIN_C2


// Macros to simplify I/O operations
//
#define RED_LED_ON      output_high(RED_LED)
#define RED_LED_OFF     output_low(RED_LED)

#define GREEN_LED_ON      output_high(GREEN_LED)
#define GREEN_LED_OFF     output_low(GREEN_LED)

#define TX_LED_ON       GREEN_LED_ON
#define TX_LED_OFF      GREEN_LED_OFF
#define RX_LED_ON       RED_LED_ON
#define RX_LED_OFF      RED_LED_OFF


#define RS232_XMIT      PIN_C6  // (output) RS232 serial transmit
#define RS232_RCV       PIN_C7  // (input) RS232 serial receive

//#define RF_XMIT			 PIN_B4
//#define RF_RCV			    PIN_B0



#define WAITING_FOR_FIRST_HEADER	1
#define WAITING_FOR_SECOND_HEADER	2
#define WAITING_FOR_CMD_BYTE		3
#define WAITING_FOR_SECOND_CMD_BYTE	4
#define CMD_READY					5



